<?php
// Данный хук показывает форму в момент редктирования (набор полей по каждому элементу отдельно)
require_once(PATH_t3lib.'class.t3lib_befunc.php');
class tx_air_table_TCEformHook {

	 /*
	 * @param	string		$tablename: Name of the current table
	 * @param	string		$table: The table of the current record
	 * @param	string		$id: The current record UID
	 * @return	void		Nothing returned. The fieldArray is directly changed, as it is passed by reference
	 */
	function getMainFields_preProcess($tablename, $row, $id) {
		global $TCA;
		
		if (is_object($GLOBALS['BE_USER']) && $TCA && $row) {

			/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
			// Сохраняем оригинал колонок, что бы их восстановить оригинал значений
			if (!isset($GLOBALS['TCA_saveOriginal']['pages']['columns'])) {
				$GLOBALS['TCA_saveOriginal']['pages']['columns'] = $GLOBALS['TCA']['pages']['columns'];
			}
			$GLOBALS['TCA']['pages']['columns'] = $GLOBALS['TCA_saveOriginal']['pages']['columns'];
			/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
		
				// Если на странице установлена галочка специальное "дополнение-контейнер"
			if ($tablename == "pages" && $row['tx_air_table_page_module_special'] == 1) {
				$GLOBALS['TCA'][$tablename]['columns']['module']['config']['type'] = "input";
			} else {
				$GLOBALS['TCA'][$tablename]['columns']['module']['config']['type'] = "select"; // = $GLOBALS['TCA'][$tablename]['columns']['module_original'];
			}
			
				// Если это pages и папка (254) и наши специальные папочки
			if($tablename == "pages"){
				if ($row['doktype'] == 254){
					if($row['module'] != "ibl_record" && $row['module'] != "ibl_insert" && $row['module'] != "ibl_other" && $row['module'] != "ibl_specl"){
						unset($GLOBALS['TCA']['pages']['columns']['tx_air_table_allowed_tables']);
					}
				}
			}
		
				// Для tt_content (если это не новая запись, включаем соритровку, т.е. если uid>0
			/*
			if($row['uid']/1 > 0) {
				$GLOBALS['TCA']['tt_content']['columns']['sorting']['label'] = 'LLL:EXT:air_table/locallang_db.xml:tx_infoblock_element.sorting';
				$GLOBALS['TCA']['tt_content']['columns']['sorting']['config'] = array ('type' => 'input', 'size' => '12', 'eval' => 'int'); 
				//$GLOBALS['TCA']['tt_content']['columns']['sorting']['displayCond'] = 'FIELD:uid:>:0'; // показываем, когда запись уже создана
				t3lib_extMgm::addToAllTCAtypes('tt_content', 'sorting', '', ''); // after:fe_group
			} else {
				unset($GLOBALS['TCA']['tt_content']['columns']['sorting']);
			}
			*/
			
				// Включаем колонки, если работает режим отдалки
			if ($GLOBALS['BE_USER']->user['ext_infoblock_flag_debug_mode'] == 0){
				foreach ($GLOBALS['TCA'][$tablename]['columns'] as $key => $value){
					if ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['editOnlyDebugMode'] == 1){
						$GLOBALS['TCA'][$tablename]['columns'][$key]['config']['readOnly'] = 1;
					}
				}
			}	
			
				// Блокируем смену типа элемента, когда элемент уже создан
			if($row['uid']/1 > 0) {
				if (isset($GLOBALS['TCA'][$tablename]['columns']['telem'])){
					$GLOBALS['TCA'][$tablename]['columns']['telem']['config']['readOnly'] = 1;
				}
			}
				
				// Для таблиц NEW-TABLE-MULTISTRUCTURE - подставляем структуры
			if (isset($GLOBALS['TCA'][$tablename]['multistructure']) &&
			isset($GLOBALS['TCA'][$tablename]['ctrl']['type'])) {
			
					// Определяем какая структура указана для записи (новая - берем по умолчанию, либо берем из записи)
				if ($tablename == "pages") {
					$telemSelected = $row['doktype'];
					// Для элементов контента
				} elseif ($tablename == "tt_content") {
					$telemSelected = $row['CType'];
				} else {
					// Для накопителей
					$telemSelected = $row['telem'];
				}
				
					// При условии, что определили
					// Подставляем структуры и что это структура определена в "multistructure"
				if (isset($GLOBALS['TCA'][$tablename]['multistructure'][$telemSelected])) {
					$GLOBALS['TCA'][$tablename]['types'][$telemSelected]['showitem'] 
					= $GLOBALS['TCA'][$tablename]['multistructure'][$telemSelected]['types']['showitem'];
						
						// Проставляем колонки (т.к. title-колонок может отличаться)
					foreach ($GLOBALS['TCA'][$tablename]['multistructure'][$telemSelected]['types']['columns'] as $kProperty => $vProperty) {
						$GLOBALS['TCA'][$tablename]['columns'][$kProperty] = $vProperty;
					}
				}
				
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
				// Сохраняем оригинал колонок, что бы их восстановить оригинал значений
				if ($tablename == "pages" && isset($GLOBALS['TCA']['pages']['multistructure'][$telemSelected]['types']['allowed_default_columns'])) {
					$allowed_default_columns = $GLOBALS['TCA']['pages']['multistructure'][$telemSelected]['types']['allowed_default_columns'];
					$allowed_default_columns = explode(",", $allowed_default_columns);
					$tempColumns = $GLOBALS['TCA']['pages']['columns'];
					$tempColumnsNew = array();
					foreach ($tempColumns as $kC => $vC){
						if (in_array($kC, $allowed_default_columns)){ // $kC != 'starttime'
							$tempColumnsNew[$kC] = $vC;
						}
					}
					$GLOBALS['TCA']['pages']['columns'] = $tempColumnsNew;
				}
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены */
				
			}
			
				// Для таблиц NEW-PAGE-MODXTV - подставляем TV-поля
			if ($tablename == "pages" && $row['module'] != "" &&
		 	isset($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV']) &&
			count($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV']) > 0) {
				$telemSelected = $row['doktype'];
				$moduleSelected = $row['module'];
				
					// При условии, что определили
					// Приклеиваем структуру TV-полей в конец
					// Исправляем небольшой баг что бы не приклеивались повторно после сохранения документа
				if (!strstr($GLOBALS['TCA']['pages']['types'][$telemSelected]['showitem'], "," . $GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['showitem'])) {
					$GLOBALS['TCA']['pages']['types'][$telemSelected]['showitem'] 
					.= "," . $GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['showitem'];
				}					
					// Проставляем колонки (т.к. title-колонок может отличаться)
				foreach ($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['columns'] as $kProperty => $vProperty) {
					$GLOBALS['TCA']['pages']['columns'][$kProperty] = $vProperty;
				}
				
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены) параметр "allowed_default_columns" */
				if ($moduleSelected != NULL && isset($GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['allowed_default_columns'])) {
					$allowed_default_columns = $GLOBALS['TCA']['pages']['multistructure_isNewPageModxTV'][$moduleSelected]['types']['allowed_default_columns'];
					$allowed_default_columns = explode(",", $allowed_default_columns);
					$tempColumns = $GLOBALS['TCA']['pages']['columns'];
					$tempColumnsNew = array();
					foreach ($tempColumns as $kC => $vC){
						if (in_array($kC, $allowed_default_columns)){ // $kC != 'starttime'
							$tempColumnsNew[$kC] = $vC;
						}
					}
					$GLOBALS['TCA']['pages']['columns'] = $tempColumnsNew;
				}
				/* 01.09.2015, NEW - убираем дефолтовые свойства (которые не разрешены */
				
			}
			
				// Если находим упрощенные записи значений SELECT, RADIO, CHECK 
			foreach($GLOBALS['TCA'][$tablename]['columns'] as $kColumn => $vColumn) {
				if ((
					$vColumn['config']['type'] == "select"
					OR
					$vColumn['config']['type'] == "radio"
					OR
					$vColumn['config']['type'] == "check"
					) 
					//AND
					//$vColumn['config']['itemsSimplifiedEntry'] = 1
				) {
					
						// Перестраиваем массив значений
					$temp = $vColumn['config']['items'];
					foreach ($temp as $kItem => $vItem) {
						if (!is_array($vItem)) {
							$GLOBALS['TCA'][$tablename]['columns'][$kColumn]['config']['items'][$kItem] = array(
								0 => $vItem,
								1 => $kItem
							);
						}
					}

				}
			}
			
				// Показываем ключе selec-ов - если работает режим отладки
			if ($GLOBALS['BE_USER']->user['ext_infoblock_flag_debug_mode'] == 1){
				foreach ($GLOBALS['TCA'][$tablename]['columns'] as $key => $value){
					if ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['type'] == "select"){
						/*
						$strlen = 0;
						foreach ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'] as $key2 => $value2){
							if ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2][1] != "--div--"){
								if (strlen($value2[1]) > $strlen){
									$strlen = strlen($value2[1]);
								}
							}
						}
						*/
						foreach ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'] as $key2 => $value2){
							if ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2][1] != "--div--"){
										
								# $nbsp = "";
								# for ($i = strlen($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2][1]); $i < $strlen; $i++){
								# 	$nbsp .= "&nbsp;";
								# }
								if ($value2[1] == null){
									$value2[1] = "-";
								}
							
									// Помечаем, если разрешены дети
									// # может содержать дочерние элементы (для defproperty->pelem)
									// STRUCTURES.directory.allowChildren = 1
								if (isset($value2[3])){
									if ($value2[3] == "+") {
										$allowChildren = " allowChildren: +";
									} else {
										$allowChildren = " allowChildren: -";
									}
								} else {
									$allowChildren = "";
								}
							
								if ($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2]['inserInfo'] == 0) {
									$GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2]['inserInfo'] = 1; // сообщяем, что уже вставили
									$GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2][0] = 
									$nbsp . " [" . $value2[1].$allowChildren."] " . trim($GLOBALS['LANG']->sL($GLOBALS['TCA'][$tablename]['columns'][$key]['config']['items'][$key2][0]));
								}
							}
						}
					}
				}
			}
			
			/*
				// Если мы в режиме отдалки - к какдой колонке выводим ее ключ
			if ($GLOBALS['BE_USER']->user['ext_infoblock_flag_debug_mode'] == 1) {
				foreach ($GLOBALS['TCA'][$tablename]['columns'] as $key => $value) {
					$getTitle = $GLOBALS['TCA'][$tablename]['columns'][$key]['label'];
					$GLOBALS['TCA'][$tablename]['columns'][$key]['label'] = $getTitle . " [".$key."]";
				}
				#if ($PA['fieldConf']['isNotModifiedColumn'] == 1){
				#	$marker['NAME'] = "<b>[<span style='color: green;'>NEW COLUMN</span>]</b> " . $marker['NAME'];
				#} elseif ($PA['fieldConf']['isModifiedColumn'] == 1){
				#	$marker['NAME'] = "<b>[<span style='color: red;'>CHANGE COLUMN</span>]</b> " . $marker['NAME'];
				#} else {
				#	$marker['NAME'] = "<b>[<span style='color: gold;'>DEFAULT</span>]</b> " . $marker['NAME'];
				#}
			}
			*/

		}
	}
	
	/**
	 * @param $table
	 * @param $field
	 * @param $row
	 * @param $altName
	 * @param $palette
	 * @param $extra
	 * @param $pal
	 * @param $parentObject
	 */
	
	/*
		Здесь исправляем небольшлой баг - если колонки разные Input и File
		к примеру, то в Input пишется лишние данные
		также пропускаются колонки типа inline
	*/
	public function getSingleField_preProcess($table, $field, &$row, $altName, $palette, $extra, $pal, $parentObject) {
			// Old version
		# $id = $row['uid'];
		# $row = t3lib_befunc::getRecord($table, $row['uid'] , "*");

			// New version
		$id = $row['uid'];
		if ($id > 0 && is_numeric($id) == TRUE) {
			# $rowOriginal = $row;
			
				// Если колонки с config.type=group (оставляем оригинал)
				// Если колонки с config.type=inline (оставляем оригинал)
				// В т.ч. понадобилось для "ColumnLibraryConfiguration.v2.0-FILES.TYPO3.6.x+.ts"
			if ((
				$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] == "group" AND
				$GLOBALS['TCA'][$table]['columns'][$field]['config']['internal_type'] == "db"
			)	OR
				$GLOBALS['TCA'][$table]['columns'][$field]['config']['type'] == "inline"
			) {
				// $row[$field] = $rowOriginal[$field]; // сохраняем оригинал
			} else {
				$db = t3lib_befunc::getRecord($table, $row['uid'] , $field);
				$row[$field] = $db[$field];
			}
		}

	}
	
}

?>